%define ver	0.3
%define rel	5
%define prefix	/usr
%define texmf	%{prefix}/share/texmf
# Define fonts.
###%define fontpath	/usr/share/fonts/zh_CN/TrueType
###%define fonts		"zysong gkai00mp"
###%define names		"song kai"
#------
%define fontpath	/dosc/windows/fonts
%define fonts		"simsun simhei simkai simfang"
%define names		"song hei kai fs"

Summary: GBK fonts for CJK
Name:	 CJK-GBKfonts
Version: %ver
Release: %rel
Serial:  3
License: distributable
Group: 	 Applications/Publishing
Source:  gbkfonts-linux-0.3.tar.bz2
#BuildPrereq: 
#Conflicts:
Provides: CJK-GBKfonts
#Requires: CJK, ttfonts-zh_CN >= 2.11-21, gawk, grep
Requires: tetex-xdvi, tetex-dvips, CJK, dvipdfmx, gawk, grep, sed
BuildRoot: %{_tmppath}/%{name}-root
Packager: Zhang Linbo <zlb@lsec.cc.ac.cn>

%description

This package creates GBK fonts for the CJK macro package.

You may modify the path to the TrueType fonts, the names of TrueType
fonts, and the names of CJK fonts through the environment variables
'TTFFONTPATH', 'TTFFONTNAMES', and 'CJKFONTNAMES', respectively,
when installing the package. For example:

  env TTFFONTPATH=/somewhere/fonts \
      TTFFONTNAMES="simsun simhei simkai simfang simli" \
      CJKFONTNAMES="song hei kai fs ls" \
      rpm -ivh %{name}-%{ver}-%{rel}.i386.rpm

You may also pass options to the 'gbkfonts' program through the variable
"GBKFONTS_OPTS". For example, 

  env GBKFONTS_OPTS="-f" rpm -ivh %{name}-%{ver}-%{rel}.i386.rpm

will update the configuration files, but will not (re)generate the
.pfb/.enc files.


%prep
%setup -q -n CJK -c

%build

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{prefix}/bin $RPM_BUILD_ROOT%{texmf}

glibc_ver=`echo /lib/libc-2.?.?.so | awk -F. '{print $2}'`
if [ "$glibc_ver" -gt 2 ]; then
    GBKFONTS=gbkfonts-glibc2.3
else
    # glibc <= 2.2, use static linked version gbkfonts
    GBKFONTS=gbkfonts
fi
cp -a gbkfonts-linux-0.3/$GBKFONTS $RPM_BUILD_ROOT%{prefix}/bin/gbkfonts

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
/*

%pre

%post

cd %texmf

fontpath=%fontpath
fonts=%fonts
names=%names

test -n "$TTFFONTPATH" && fontpath="$TTFFONTPATH"
test -n "$TTFFONTNAMES" && fonts="$TTFFONTNAMES"
test -n "$CJKFONTNAMES" && names="$CJKFONTNAMES"

echo 1>&2 "Creating T1 fonts (fontpath=$fontpath):"
echo 1>&2 "    Path to TTF fonts: $fontpath"
echo 1>&2 "       TTF font names: $fonts"
echo 1>&2 "       CJK font names: $names"

# First, make sure all TrueType fonts exists
tmp=""
for f in $fonts; do
    if test -r ${fontpath}/${f}.ttf; then
	tmp="$tmp ${f}.ttf"
	continue
    fi
#    if test -r ${fontpath}/${f}.ttc; then
#	tmp="$tmp ${f}.ttc"
#	continue
#    fi
    echo 1>&2 "Error: cannot find TrueType font ${fontpath}/${f}.ttf"
    echo 1>&2 "Please provide correct font path and names using" \
	      "environment variables"
    echo 1>&2 "(type 'rpm -qip %{name}-%{ver}-%{rel}.i386.rpm' for details)"
    exit -1
done
fonts="$tmp"

# Save information for uninstall
echo "fontpath=$fontpath" > ./CJK-GBKfonts.info
echo "fonts=\"$fonts\"" >> ./CJK-GBKfonts.info
echo "names=\"$names\"" >> ./CJK-GBKfonts.info

set -- $names
for f in $fonts; do
    # --- don't generate .pfb/.enc files (fast), for debugging
    # %{prefix}/bin/gbkfonts -f ${fontpath}/${f} $1
    # ---
    if [ -z "$GBKFONTS_OPTS" ]; then
	%{prefix}/bin/gbkfonts ${fontpath}/${f} $1
    else
	%{prefix}/bin/gbkfonts $GBKFONTS_OPTS ${fontpath}/${f} $1
    fi
    shift 1
done

#--- dvips
mkdir -p %{texmf}/dvips/config
mv -f cjk.map %{texmf}/dvips/config/cjk.map
test -f %{texmf}/dvips/config/config.ps && \
	! grep -q '^p +cjk.map$' %{texmf}/dvips/config/config.ps && \
	echo 'p +cjk.map' >>%{texmf}/dvips/config/config.ps

#--- xdvi
test -f %{texmf}/xdvi/xdvi.cfg && \
	! grep -q '^dvipsmap cjk.map$' %{texmf}/xdvi/xdvi.cfg && \
	echo 'dvipsmap cjk.map' >>%{texmf}/xdvi/xdvi.cfg

#--- pdftex
mkdir -p %{texmf}/pdftex/config
for n in $names; do
    test -f %{texmf}/pdftex/config/pdftex.cfg && \
	! grep -q '^map +gbk'$n'.map$' %{texmf}/pdftex/config/pdftex.cfg && \
	echo 'map +gbk'$n'.map' >>%{texmf}/pdftex/config/pdftex.cfg
done
awk 'BEGIN {ttfpath="'${fontpath}'//"}
    {
	if ( $1 != "TTFONTS" ) {
	    print
	} else {
	    if ( !index($3, ";" ttfpath) ) {
		printf "TTFONTS = %s;%s\n", $3, ttfpath
	    } else {
		print
	    }
	}
    }' %{texmf}/web2c/texmf.cnf >tmp
    mv -f tmp %{texmf}/web2c/texmf.cnf

#--- dvipdfm
mkdir -p %{texmf}/dvipdfm/config
if [ -f %{texmf}/dvipdfm/config/cid-x.map ]; then
    egrep -v `awk '{printf "%s|", $1}' cid-x.map | sed -e 's/|$//'` \
	%{texmf}/dvipdfm/config/cid-x.map >%{texmf}/dvipdfm/config/tmp
    mv -f %{texmf}/dvipdfm/config/tmp %{texmf}/dvipdfm/config/cid-x.map
    cat cid-x.map >> %{texmf}/dvipdfm/config/cid-x.map
else
    mv -f cid-x.map %{texmf}/dvipdfm/config/cid-x.map
fi

#--- ttf2pk
###mkdir -p %{texmf}/ttf2pk
###mv -f ttfonts.map %{texmf}/ttf2pk/ttfonts.map

rm -f cid-x.map cjk.map pdftex.cfg ttfonts.map
texhash

%preun

cd %{texmf}

if test -r ./CJK-GBKfonts.info; then
    . ./CJK-GBKfonts.info
else
    names=%names
fi
for n in $names; do
    rm -f dvips/chinese/gbk${n}/gbk${n}*.enc
    test -d dvips/chinese/gbk${n} && \
	rmdir --ignore-fail-on-non-empty -p dvips/chinese/gbk${n}

    for d in afm tfm type1; do 
	rm -f fonts/${d}/chinese/gbk${n}/gbk${n}*.*
	test -d fonts/${d}/chinese/gbk${n} && \
		rmdir --ignore-fail-on-non-empty -p fonts/${d}/chinese/gbk${n}
    done

    rm -f tex/latex/CJK/GB/c19${n}.fd
    rm -f pdftex/config/gbk${n}.map
    rm -f dvipdfm/config/gbk${n}.map
done

test -d dvipdfm/config && \
	rmdir --ignore-fail-on-non-empty -p dvipdfm/config

test -d tex/latex/CJK/GB && \
	rmdir --ignore-fail-on-non-empty -p tex/latex/CJK/GB

test -d pdftex/config && \
	rmdir --ignore-fail-on-non-empty -p pdftex/config

%postun

texhash

%changelog
* Wed May 28 2003 Zhang Lin-bo <zlb@lsec.cc.ac.cn>
- Check version of glibc when installing gbkfonts.

* Mon May 19 2003 Zhang Lin-bo <zlb@lsec.cc.ac.cn>
- Append 'dvipsmap cjk.map' line to %{texmf}/xdvi/xdvi.cfg

* Sat Jan 04 2003 Zhang Lin-bo <zlb@lsec.cc.ac.cn>
- Created the package.
